#!/usr/bin/env python
# -*- coding: utf-8 -*-
version = '0.001'
"""

Copyright John Thornton 2012
"""

try:
  import pygtk
  pygtk.require('2.0')
except:
  pass
try:
  import gtk
  import gtk.glade
except:
  print('GTK not available')
  sys.exit(1)

import database as db

class sfc2:

  def __init__(self):
    self.builder = gtk.Builder()
    self.builder.add_from_file("sfc2.glade")
    self.builder.connect_signals(self)

    self.db = db.database()
    self.thread_form = []
    self.thread_size = []
    self.thread_class = []

    self.formlist = gtk.ListStore(str)
    self.formlist.append(["Select a Form"])
    self.itemlist = self.db.thread_forms()
    for i in self.itemlist:
      self.formlist.append([i["form"]])
    self.form_combo = self.builder.get_object("form_combo")
    self.form_combo.set_model(self.formlist)
    self.form_cell = gtk.CellRendererText()
    self.form_combo.pack_start(self.form_cell)
    self.form_combo.add_attribute(self.form_cell, 'text', 0)
    self.form_combo.set_active(0)

    self.thread_size_list = gtk.ListStore(str)
    self.thread_size_combo = self.builder.get_object("thread_size_combo")
    self.thread_size_combo.set_model(self.thread_size_list)
    self.thread_size_cell = gtk.CellRendererText()
    self.thread_size_combo.pack_start(self.thread_size_cell)
    self.thread_size_combo.add_attribute(self.thread_size_cell, 'text', 0)

    self.thread_class_list = gtk.ListStore(str)
    self.thread_class_combo = self.builder.get_object("thread_class_combo")
    self.thread_class_combo.set_model(self.thread_class_list)
    self.thread_class_cell = gtk.CellRendererText()
    self.thread_class_combo.pack_start(self.thread_class_cell)
    self.thread_class_combo.add_attribute(self.thread_class_cell, 'text', 0)

    self.window = self.builder.get_object("window1")
    self.window.set_title("Machinist Calculator")
    self.window.show_all()

  def on_form_combo_changed(self, widget, data=None):
    self.index = widget.get_active()
    if self.index > 0:
      self.model = widget.get_model()
      self.item = [self.model[self.index][0]]
      self.thread_form = self.item
      self.thread_size_list.clear()
      self.thread_class_list.clear()
      self.itemlist = self.db.thread_size(self.item)
      self.thread_size_list.append(['Select a Size'])
      for i in self.itemlist:
        self.thread_size_list.append([i["size"]])
      self.thread_size_combo.set_active(0)

  def on_thread_size_combo_changed(self, widget, data=None):
    self.index = widget.get_active()
    if self.index > 0:
      self.model = widget.get_model()
      self.item = [self.model[self.index][0]]
      self.thread_size = self.item
      self.thread_class_list.clear()
      self.thread_class_list.append(['Select a Class'])
      self.itemlist = self.db.thread_class(self.item)
      for i in self.itemlist:
        self.thread_class_list.append([i["class"]])
      self.thread_class_combo.set_active(0)

  def on_thread_class_combo_changed(self, widget, data=None):
    self.index = widget.get_active()
    if self.index > 0:
      self.model = widget.get_model()
      self.item = [self.model[self.index][0]]
      self.thread_class = self.item
      self.thread_info = self.db.thread_info(self.thread_form, self.thread_size, self.thread_class)
      for i in self.thread_info:
        self.pitch = i['pitch']
        self.major_dia = i['major_dia']
        self.max_major_dia = i['max_major_dia']
        self.min_major_dia = i['min_major_dia']
        self.pitch_dia = i['pitch_dia']
        self.max_pitch_dia = i['max_pitch_dia']
        self.min_pitch_dia = i['min_pitch_dia']
        self.max_minor_dia = i['max_minor_dia']
        self.wire_size = i['wire_size']
      self.builder.get_object("max_major_dia").set_text(str(self.max_major_dia) + '"')
      self.builder.get_object("major_dia").set_text(str(self.major_dia) + '"')
      self.builder.get_object("min_major_dia").set_text(str(self.min_major_dia) + '"')
      self.builder.get_object("max_pitch_dia").set_text(str(self.max_pitch_dia) + '"')
      self.builder.get_object("pitch_dia").set_text(str(self.pitch_dia) + '"')
      self.builder.get_object("min_pitch_dia").set_text(str(self.min_pitch_dia) + '"')
      self.builder.get_object("max_minor_dia").set_text(str(self.max_minor_dia) + '"')
      if self.wire_size > 0:
        self.builder.get_object("thread_wire_dia").set_text(str(self.wire_size) + '"')
        self.builder.get_object("measure_over_wires").set_text(str(round(self.major_dia - (1.51555/self.pitch)+ (3*self.wire_size),4)))
        self.builder.get_object("measured_pitch_dia").set_text(self.calc_pitch_dia())
      else:
        self.builder.get_object("thread_wire_dia").set_text('n/a')
      self.drill_list()

  def drill_list(self):
    self.index = self.builder.get_object('thread_class_combo').get_active()
    if self.index > 0:
      self.fractional_drills = self.builder.get_object("cb_fractional_drills")
      self.number_drills = self.builder.get_object("cb_number_drills")
      self.letter_drills = self.builder.get_object("cb_letter_drills")
      self.metric_drills = self.builder.get_object("cb_metric_drills")
      self.range = []
      if self.fractional_drills.get_active():
        self.range.append("F")
      if self.number_drills.get_active():
        self.range.append("N")
      if self.letter_drills.get_active():
        self.range.append("L")
      if self.metric_drills.get_active():
        self.range.append("M")
      self.query = 'SELECT * FROM drills WHERE type IN (%s)' % ','.join('?' for i in self.range)
      self.query += " AND diam >= ? AND diam <= ?"
      self.drill100 = str(round(self.major_dia - ((0.01299 * 100) / self.pitch),5))
      self.drill50 = str(round(self.major_dia - ((0.01299 * 50) / self.pitch),5))
      self.range.append(self.drill100)
      self.range.append(self.drill50)
      dlist = self.db.drill_list(self.query, self.range)
      self.drilllist = ''
      for i in dlist:
        self.drilllist += str(i["type"]) + '\n'
      self.builder.get_object("drill_type").set_text(self.drilllist)
      self.drilllist = ''
      for i in dlist:
        self.drilllist += str(i["size"]) + '\n'
      self.builder.get_object("drill_size").set_text(self.drilllist)
      self.drilllist = ''
      for i in dlist:
        self.drilllist += str(i["diam"]) + '\n'
      self.builder.get_object("drill_diameter").set_text(self.drilllist)
      self.drilllist = ''
      for i in dlist:
        self.percent = str(round(((self.major_dia - i["diam"])/0.1299) * self.pitch ,2)*10)
        self.drilllist += self.percent + '%\n'
      self.builder.get_object("thread_percent").set_text(self.drilllist)

  def on_cb_fractional_drills_toggled(self, widget, data=None):
    self.drill_list()

  def on_cb_number_drills_toggled(self, widget, data=None):
    self.drill_list()

  def on_cb_letter_drills_toggled(self, widget, data=None):
    self.drill_list()

  def on_cb_metric_drills_toggled(self, widget, data=None):
    self.drill_list()


  def on_measure_over_wires_activate(self, widget, data=None):
    self.builder.get_object("measured_pitch_dia").set_text(self.calc_pitch_dia())

  def calc_pitch_dia(self):
    self.measure = float(self.builder.get_object('measure_over_wires').get_text())
    return str(round(self.measure-((3*self.wire_size) - (0.86603 / self.pitch)),4))

  def on_window1_destroy(self, object, data=None):
    print "quit with cancel"
    gtk.main_quit()

  def on_menu_quit_activate(self, menuitem, data=None):
    print "quit from menu"
    gtk.main_quit()

if __name__ == "__main__":
  main = sfc2()
  gtk.main()
